#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
#-----------------------------------------------------------------------------
Name		:	vzgot
Version		:	0.99.7.13
Release		:	17.2.37.rel%{?dist}
Summary		:	An application to drive linux container
Group		:	System Environment/Daemons

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	GPLv2+
URL		:	http://www.osukiss.org

Source0		:	%{name}-%{version}.tar.gz
#-----------------------------------------------------------------------------
BuildRequires	:	gcc
BuildRequires	:	make
BuildRequires	:	libcap-devel
BuildRequires	:	kernel-headers

Requires	:	bash
Requires	:	bc
Requires	:	bind-utils
Requires	:	bridge-utils
Requires	:	coreutils
Requires	:	iproute
Requires	:	procps-ng
Requires	:	sed
Requires	:	util-linux

BuildArch	:	x86_64

#-----------------------------------------------------------------------------
%description
vzgot is a set of tool to manage linux container
it allow to run a wide range of distribution, as
long their kernel is a Linux one

#-----------------------------------------------------------------------------
%files			
%defattr(-, root,root,-)
%doc %{name}-%{version}.build_date
%doc README Changes QUICK-START
%dir %{_var}/run/%{name}
%dir /%{name}
%dir /vzcgroup
%{_var}/lib/%{name}/RPM
%{_var}/lib/%{name}/etc/ssh
%{_var}/lib/%{name}/cgroup.d/
%{_var}/lib/%{name}/vztemplates
%{_var}/lib/%{name}/contrib/*
%{_usr}/sbin/%{name}
%{_var}/lib/%{name}/shell/%{name}.build
%{_var}/lib/%{name}/shell/%{name}.close
%{_var}/lib/%{name}/shell/%{name}.create
%{_var}/lib/%{name}/shell/%{name}.destroy
%{_var}/lib/%{name}/shell/%{name}.exec
%{_var}/lib/%{name}/shell/%{name}.freeze
%{_var}/lib/%{name}/shell/%{name}.fboot
%{_var}/lib/%{name}/shell/%{name}.fboot.redhat
%{_var}/lib/%{name}/shell/%{name}.fboot.debian
%{_var}/lib/%{name}/shell/%{name}.fboot.osukiss
%{_var}/lib/%{name}/shell/%{name}.list
%{_var}/lib/%{name}/shell/%{name}.online
%{_var}/lib/%{name}/shell/%{name}.open
%{_var}/lib/%{name}/shell/%{name}.net
%{_var}/lib/%{name}/shell/%{name}.movefrom
%{_var}/lib/%{name}/shell/%{name}.rebuild
%{_var}/lib/%{name}/shell/%{name}.start
%{_var}/lib/%{name}/shell/%{name}.standby
%{_var}/lib/%{name}/shell/vzctl.standby
%dir %{_sysconfdir}/%{name}/sites_data
%dir %{_sysconfdir}/%{name}/names
%config(noreplace) %{_sysconfdir}/%{name}/vzgot_config
%config(noreplace) %{_sysconfdir}/%{name}/vzgot_list
%config(noreplace) %{_sysconfdir}/sysctl.d//%{name}.conf
%config(noreplace) %{_var}/lib/%{name}/etc/shadow
%config(noreplace) %{_var}/lib/%{name}/etc/resolv.conf
%config(noreplace) %{_var}/lib/%{name}/etc/groups
%config(noreplace) %{_var}/lib/%{name}/etc/users
%config(noreplace) %{_var}/lib/%{name}/etc/sudoers
%config(noreplace) %{_var}/lib/%{name}/etc/sysconfig/iptables
%config(noreplace) %{_var}/lib/%{name}/etc/snmp/snmpd.conf

#after install or upgrade
%post
if [ "$1" = 1 ]; then
 sysctl -p > /dev/null 2>&1
 #extracting HOST root password to be used as container common password
 /bin/chmod 600 %{_var}/lib/%{name}/etc/shadow
 /bin/sed 's/#.*//g' /etc/shadow	|	\
	grep -v '^[[:space:]]*$' 	|	\
	grep root >>  %{_var}/lib/%{name}/etc/shadow
 #extracting HOST nameserver to be used by container
 if [ -f /etc/resolv.conf ] ; then
   (						\
   echo    "#Installation HOST: $HOSTNAME";	\
   echo -n "#Installation date: ";		\
   date	;					\
   head -1 %{_var}/lib/%{name}/etc/resolv.conf;	\
   /bin/sed 's/#.*//g' /etc/resolv.conf;	\
   ) >> %{_var}/lib/%{name}/etc/resolv.conf
   fi
 #populating ssh default directory
 if [ -f /etc/*ssh/sshd_config ] ; then
   cp -a					\
	/etc/*ssh/sshd_config	 		\
	/var/lib/%{name}/etc/ssh/server
   fi
 if [ -f ~/.ssh/authorized_keys ] ; then
   cp -a					\
	~/.ssh/authorized_keys			\
	/var/lib/%{name}/etc/ssh/access
   fi
 fi

#=============================================================================
%package		sysv
Summary		:       %{name} configuration file for sysV

#-----------------------------------------------------------------------------
Requires	:	chkconfig
Requires        :       lfs-bootscripts
Requires        :       %{name} = %{version}-%{release}

BuildArch	:	noarch

#-----------------------------------------------------------------------------
%description            sysv
This package allow to use vzgot on a simple sysv (sysvinit)
linux system.

#-----------------------------------------------------------------------------
Requires	:	lsb

#-----------------------------------------------------------------------------
%files                  sysv
%defattr(-, root,root,-)
%config(noreplace,missingok) %{_sysconfdir}/sysconfig/ifconfig.vz-br0
%{_initrddir}/%{name}

#-----------------------------------------------------------------------------
%post			sysv
if [ "$1" = 1 ]; then
  %{_sbindir}/ifup vz-br0 2> /dev/null
  %{_sbindir}/chkconfig %{name} on 2>/dev/null || :
  fi

#after upgrade or remove
%preun			sysv
if [ "$1" = 0 ]; then
  %{_initrddir}/%{name} stop 2>/dev/null || :
  %{_sbindir}/chkconfig --del %{name} 2>/dev/null || :
  %{_sbindir}/ifdown vz-br0 2> /dev/null
  fi

#=============================================================================
%package		systemd
Summary		:       %{name} configuration file for systemd

#-----------------------------------------------------------------------------
Requires        :       %{name} = %{version}-%{release}

BuildArch	:	noarch
#-----------------------------------------------------------------------------
%description            systemd
This package allow to use vzgot on a linux systemd system.

#-----------------------------------------------------------------------------
%files                  systemd
%defattr(-, root,root,-)
%{_var}/lib/%{name}/systemd/%{name}.init
%config(noreplace) %attr(0600,root,root) %{_sysconfdir}/NetworkManager/system-connections/vz-br0.nmconnection
%{_prefix}/lib/systemd/system/%{name}.service

#-----------------------------------------------------------------------------
%post			systemd
if [ "$1" = 1 ]; then
  systemctl enable %{name}.service
  systemctl start %{name}.service
  systemctl reload NetworkManager.service
  systemctl restart NetworkManager.service
  fi
systemctl daemon-reload
systemctl reload %{name}.service

#after upgrade or remove
%preun			systemd
if [ "$1" = 0 ]; then
  systemctl stop %{name}.service
  systemctl disable %{name}.service
  systemctl daemon-reload
  systemctl reload NetworkManager.service
  systemctl restart NetworkManager.service
  fi

#=============================================================================
%prep
%setup -q

#-----------------------------------------------------------------------------
#building application
%build

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make}						\
	%{?_smp_mflags}					\
	prod

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__mkdir_p} -m 0755 %{buildroot}/etc/%{name}/sites_data
%{__mkdir_p} -m 0755 %{buildroot}/etc/%{name}/names
%{__mkdir_p} -m 0700 %{buildroot}/vzcgroup
%{__mkdir_p} -m 0700 %{buildroot}/%{name}

%{__make}						\
	DESTDIR="%{buildroot}"				\
	install

#-----------------------------------------------------------------------------
%changelog
%autochangelog

#-----------------------------------------------------------------------------
